package
{
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import Page;
	import Sign;
	import Vera;
	
	public class Simu extends Sprite
	{	
		private var d:Sprite = new Sprite(); // affichage de la courbe
		private var s:Sign; // le signal affiché
		
		private var g:Sprite = new Sprite(); // interface du GBF
		
		private var l:Sprite = new Sprite(); // lcd
		private var lct:Vera = new Vera('lol', 70, 'c', 16, 'vert');
		private var l1:Sprite = new Sprite(); // led Hz
		private var l2:Sprite = new Sprite(); // led kHz
		
		private var bp1:Sprite = new Sprite(); // 1er bouton de pas
		private var bp2:Sprite = new Sprite(); // 2eme bouton de pas
		private var bp3:Sprite = new Sprite(); // 3eme bouton de pas
		private var bp4:Sprite = new Sprite(); // 4eme bouton de pas
		private var bp5:Sprite = new Sprite(); // 5eme bouton de pas
		
		private var bf1:Sprite = new Sprite; // bouton de forme sinusoide
		private var lf1:Vera = new Vera('sin', 20, 'l', 10);
		private var bf2:Sprite = new Sprite; // bouton de forme rectangulaire
		private var lf2:Vera = new Vera('rec', 20, 'l', 10);
		private var bf3:Sprite = new Sprite; // bouton de forme triangulaire
		private var lf3:Vera = new Vera('tri', 20, 'l', 10);
		
		private var bf:Sprite = new Sprite(); // bouton frequence
		private var f1:Number; // position du clic sur le bouton frequence
		private var br:Sprite = new Sprite; // bouton rapport cyclique
		private var r1:Number; // position du clic sur le bouton rapport
		private var bo:Sprite = new Sprite; // bouton offset
		private var o1:Number; // position du clic sur le bouton offset
		private var ba:Sprite = new Sprite; // bouton amplitude
		private var a1:Number; // position du clic sur le bouton amplitude
		
		private var cs:Vera = new Vera('', 420, 'l', 10); // consigne
		
		// valeurs de l evaluation
		private var ef:Number; // frequence
		private var et:int; // pas temporel
		private var ea:Number; // amplitude
		private var eo:Number; // offset
		private var es:String; // forme du signal
		private var er:Number; // rapport cyclique
		
		public function Simu(eval:Boolean = false):void
		{
			if(eval == true)
			{
				evalea(); // evaluation et consigne
			}
			else
			{
				cs.setTexte('Utilisez les touches du GBF ci-dessous pour modifier le signal généré.');
			}
			this.addChild(cs); // affichage de la consigne
			this.skin(); // construction de l'interface
		}
		
		public function skin():void
		{
			// affichage de la courbe
			d.graphics.lineStyle(3, 0xbbdddd);
			d.graphics.beginFill(0xFFFFFF);
			d.graphics.drawRoundRect(0, 0, 320, 200, 10, 10);
			d.x = 50;
			d.y = 140;
			this.addChild(d);
			
			s = new Sign(300, 180, 's', 1, 10, 0, 0.5, false, false);
			s.x = 60;
			s.y = 150;
			this.addChild(s);
			
			// interface du gbf
			g.graphics.lineStyle(3, 0xbbdddd);
			g.graphics.beginFill(0xFFFFFF);
			g.graphics.drawRoundRect(0, 0, 420, 100, 10, 10);
			g.y = 30;
			g.mouseChildren = true;
			this.addChild(g);
			
			// LCD
			l.graphics.lineStyle(3, 0xbbdddd);
			l.graphics.drawRoundRect(0, 0, 80, 25, 5, 5);
			l.y = 10;
			l.x = 10;
			g.addChild(l);
			
			// texte du LCD
			lct.y = 3;
			lct.x = 5;
			l.addChild(lct);
			lct.setTexte('1');
			
			// LED Hz
			l1.graphics.lineStyle(3, 0x00bb99);
			l1.graphics.lineTo(10, 0);
			l1.x = 90;
			l1.y = 17;
			l1.name = 'l1';
			g.addChild(l1);
			var l1t:Vera = new Vera('Hz', 40, 'l', 10);
			l1t.x = 100;
			l1t.y = 10;
			g.addChild(l1t);
			
			// LED kHz
			l2.graphics.lineStyle(3, 0xbbdddd);
			l2.graphics.lineTo(10, 0);
			l2.x = 90;
			l2.y = 27;
			l2.name = 'l2';
			g.addChild(l2);
			var l2t:Vera = new Vera('kHz', 40, 'l', 10);
			l2t.x = 100;
			l2t.y = 20;
			g.addChild(l2t);
			
			// boutons d echele temporelle
			
			bp1.graphics.lineStyle(3, 0x00bb99);
			bp1.graphics.beginFill(0x00bb99);
			bp1.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bp1.y = 20;
			bp1.x = 150;
			bp1.name = 'p1';
			bp1.buttonMode = true;
			bp1.addEventListener(MouseEvent.MOUSE_DOWN, clickedPas);
			g.addChild(bp1);
			var lp1:Vera = new Vera('1Hz', 40, 'l', 10);
			lp1.y = 30;
			lp1.x = 140;
			g.addChild(lp1);
			
			bp2.graphics.lineStyle(3, 0x00bb99);
			bp2.graphics.beginFill(0xFFFFFF);
			bp2.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bp2.y = 20;
			bp2.x = 180;
			bp2.name = 'p2';
			bp2.buttonMode = true;
			bp2.addEventListener(MouseEvent.MOUSE_DOWN, clickedPas);
			g.addChild(bp2);
			var lp2:Vera = new Vera('10Hz', 40, 'l', 10);
			lp2.y = 30;
			lp2.x = 165;
			g.addChild(lp2);
			
			bp3.graphics.lineStyle(3, 0x00bb99);
			bp3.graphics.beginFill(0xFFFFFF);
			bp3.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bp3.y = 20;
			bp3.x = 210;
			bp3.name = 'p3';
			bp3.buttonMode = true;
			bp3.addEventListener(MouseEvent.MOUSE_DOWN, clickedPas);
			g.addChild(bp3);
			var lp3:Vera = new Vera('100Hz', 40, 'l', 10);
			lp3.y = 30;
			lp3.x = 195;
			g.addChild(lp3);
			
			bp4.graphics.lineStyle(3, 0x00bb99);
			bp4.graphics.beginFill(0xFFFFFF);
			bp4.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bp4.y = 20;
			bp4.x = 240;
			bp4.name = 'p4';
			bp4.buttonMode = true;
			bp4.addEventListener(MouseEvent.MOUSE_DOWN, clickedPas);
			g.addChild(bp4);
			var lp4:Vera = new Vera('1kHz', 40, 'l', 10);
			lp4.y = 30;
			lp4.x = 230;
			g.addChild(lp4);
			
			bp5.graphics.lineStyle(3, 0x00bb99);
			bp5.graphics.beginFill(0xFFFFFF);
			bp5.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bp5.y = 20;
			bp5.x = 270;
			bp5.name = 'p5';
			bp5.buttonMode = true;
			bp5.addEventListener(MouseEvent.MOUSE_DOWN, clickedPas);
			g.addChild(bp5);
			var lp5:Vera = new Vera('10kHz', 40, 'l', 10);
			lp5.y = 30;
			lp5.x = 260;
			g.addChild(lp5);
			
			// boutons de forme du signal
			
			bf1.graphics.lineStyle(3, 0x00bb99);
			bf1.graphics.beginFill(0x00bb99);
			bf1.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bf1.y = 20;
			bf1.x = 330;
			bf1.name = 'f1';
			bf1.buttonMode = true;
			bf1.addEventListener(MouseEvent.MOUSE_DOWN, clickedForme);
			g.addChild(bf1);
			lf1.y = 30;
			lf1.x = 325;
			g.addChild(lf1);
			
			bf2.graphics.lineStyle(3, 0x00bb99);
			bf2.graphics.beginFill(0xFFFFFF);
			bf2.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bf2.y = 20;
			bf2.x = 360;
			bf2.name = 'f2';
			bf2.buttonMode = true;
			bf2.addEventListener(MouseEvent.MOUSE_DOWN, clickedForme);
			g.addChild(bf2);
			lf2.y = 30;
			lf2.x = 355;
			g.addChild(lf2);
			
			bf3.graphics.lineStyle(3, 0x00bb99);
			bf3.graphics.beginFill(0xFFFFFF);
			bf3.graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			bf3.y = 20;
			bf3.x = 390;
			bf3.name = 'f3';
			bf3.buttonMode = true;
			bf3.addEventListener(MouseEvent.MOUSE_DOWN, clickedForme);
			g.addChild(bf3);
			lf3.y = 30;
			lf3.x = 388;
			g.addChild(lf3);
			
			// bouton frequence et ses graduation
			
			bf.graphics.lineStyle(3, 0x00bb99);
			bf.graphics.beginFill(0xFFFFFF);
			bf.graphics.drawCircle(0, 0, 20);
			bf.graphics.moveTo(0, -20);
			bf.graphics.lineTo(0, -10);
			bf.y = 65;
			bf.x = 65;
			bf.buttonMode = true;
			bf.rotation = 30;
			bf.addEventListener(MouseEvent.MOUSE_DOWN, clickedFreq);
			g.addChild(bf);
			var bfg1:Sprite = new Sprite();
			bfg1.graphics.beginFill(0x00bb99);
			bfg1.graphics.drawCircle(0, 0, 2);
			bfg1.y = 77;
			bfg1.x = 44;
			g.addChild(bfg1);
			var bfl1:Vera = new Vera('0.5', 25, 'l', 10);
			bfl1.y = 70;
			bfl1.x = 22;
			g.addChild(bfl1);
			var bfg2:Sprite = new Sprite();
			bfg2.graphics.beginFill(0x00bb99);
			bfg2.graphics.drawCircle(0, 0, 2);
			bfg2.y = 65;
			bfg2.x = 40;
			g.addChild(bfg2);
			var bfg3:Sprite = new Sprite();
			bfg3.graphics.beginFill(0x00bb99);
			bfg3.graphics.drawCircle(0, 0, 2);
			bfg3.y = 54;
			bfg3.x = 43;
			g.addChild(bfg3);
			var bfg4:Sprite = new Sprite();
			bfg4.graphics.beginFill(0x00bb99);
			bfg4.graphics.drawCircle(0, 0, 2);
			bfg4.y = 44;
			bfg4.x = 51;
			g.addChild(bfg4);
			var bfg5:Sprite = new Sprite();
			bfg5.graphics.beginFill(0x00bb99);
			bfg5.graphics.drawCircle(0, 0, 2);
			bfg5.y = 41;
			bfg5.x = 65;
			g.addChild(bfg5);
			var bfg6:Sprite = new Sprite();
			bfg6.graphics.beginFill(0x00bb99);
			bfg6.graphics.drawCircle(0, 0, 2);
			bfg6.y = 44;
			bfg6.x = 77;
			g.addChild(bfg6);
			var bfl6:Vera = new Vera('1', 10, 'l', 10);
			bfl6.y = 35;
			bfl6.x = 79;
			g.addChild(bfl6);
			var bfg7:Sprite = new Sprite();
			bfg7.graphics.beginFill(0x00bb99);
			bfg7.graphics.drawCircle(0, 0, 2);
			bfg7.y = 54;
			bfg7.x = 87;
			g.addChild(bfg7);
			var bfg8:Sprite = new Sprite();
			bfg8.graphics.beginFill(0x00bb99);
			bfg8.graphics.drawCircle(0, 0, 2);
			bfg8.y = 65;
			bfg8.x = 89;
			g.addChild(bfg8);
			var bfg9:Sprite = new Sprite();
			bfg9.graphics.beginFill(0x00bb99);
			bfg9.graphics.drawCircle(0, 0, 2);
			bfg9.y = 77;
			bfg9.x = 87;
			g.addChild(bfg9);
			var bfl5:Vera = new Vera('4', 10, 'l', 10);
			bfl5.y = 70;
			bfl5.x = 90;
			g.addChild(bfl5);
			var lbf:Vera = new Vera('Fréquence', 70, 'l', 10);
			lbf.y = 85;
			lbf.x = 40;
			g.addChild(lbf);
			
			// bouton rapport cyclique et ses graduation
			
			br.graphics.lineStyle(3, 0x00bb99);
			br.graphics.beginFill(0xFFFFFF);
			br.graphics.drawCircle(0, 0, 15);
			br.graphics.moveTo(0, -15);
			br.graphics.lineTo(0, -5);
			br.y = 70;
			br.x = 175;
			br.buttonMode = true;
			br.addEventListener(MouseEvent.MOUSE_DOWN, clickedRap);
			g.addChild(br);
			var brg1:Sprite = new Sprite();
			brg1.graphics.beginFill(0x00bb99);
			brg1.graphics.drawCircle(0, 0, 2);
			brg1.y = 60;
			brg1.x = 158;
			g.addChild(brg1);
			var brl1:Vera = new Vera('0.25', 30, 'l', 10);
			brl1.y = 53;
			brl1.x = 127;
			g.addChild(brl1);
			var brg3:Sprite = new Sprite();
			brg3.graphics.beginFill(0x00bb99);
			brg3.graphics.drawCircle(0, 0, 2);
			brg3.y = 51;
			brg3.x = 175;
			g.addChild(brg3);
			var brg5:Sprite = new Sprite();
			brg5.graphics.beginFill(0x00bb99);
			brg5.graphics.drawCircle(0, 0, 2);
			brg5.y = 60;
			brg5.x = 192;
			g.addChild(brg5);
			var brl5:Vera = new Vera('0.75', 30, 'l', 10);
			brl5.y = 53;
			brl5.x = 198;
			g.addChild(brl5);
			var lbr:Vera = new Vera('Rapport cyclique', 90, 'l', 10);
			lbr.y = 85;
			lbr.x = 135;
			g.addChild(lbr);
			
			// bouton offset et ses graduactions
			
			bo.graphics.lineStyle(3, 0x00bb99);
			bo.graphics.beginFill(0xFFFFFF);
			bo.graphics.drawCircle(0, 0, 15);
			bo.graphics.moveTo(0, -15);
			bo.graphics.lineTo(0, -5);
			bo.y = 70;
			bo.x = 275;
			bo.buttonMode = true;
			bo.addEventListener(MouseEvent.MOUSE_DOWN, clickedOff);
			g.addChild(bo);
			var bog1:Sprite = new Sprite();
			bog1.graphics.beginFill(0x00bb99);
			bog1.graphics.drawCircle(0, 0, 2);
			bog1.y = 80;
			bog1.x = 258;
			g.addChild(bog1);
			var bol1:Vera = new Vera('-10', 25, 'l', 10);
			bol1.y = 73;
			bol1.x = 232;
			g.addChild(bol1);
			var bog2:Sprite = new Sprite();
			bog2.graphics.beginFill(0x00bb99);
			bog2.graphics.drawCircle(0, 0, 2);
			bog2.y = 60;
			bog2.x = 258;
			g.addChild(bog2);
			var bog3:Sprite = new Sprite();
			bog3.graphics.beginFill(0x00bb99);
			bog3.graphics.drawCircle(0, 0, 2);
			bog3.y = 51;
			bog3.x = 275;
			g.addChild(bog3);
			var bog4:Sprite = new Sprite();
			bog4.graphics.beginFill(0x00bb99);
			bog4.graphics.drawCircle(0, 0, 2);
			bog4.y = 60;
			bog4.x = 292;
			g.addChild(bog4);
			var bog5:Sprite = new Sprite();
			bog5.graphics.beginFill(0x00bb99);
			bog5.graphics.drawCircle(0, 0, 2);
			bog5.y = 80;
			bog5.x = 292;
			g.addChild(bog5);
			var bol5:Vera = new Vera('10', 20, 'l', 10);
			bol5.y = 73;
			bol5.x = 295;
			g.addChild(bol5);
			var lbo:Vera = new Vera('Offset (V)', 70, 'l', 10);
			lbo.y = 85;
			lbo.x = 250;
			g.addChild(lbo);
			
			// bouton amplitude
			
			ba.graphics.lineStyle(3, 0x00bb99);
			ba.graphics.beginFill(0xFFFFFF);
			ba.graphics.drawCircle(0, 0, 15);
			ba.graphics.moveTo(0, -15);
			ba.graphics.lineTo(0, -5);
			ba.y = 70;
			ba.x = 375;
			ba.buttonMode = true;
			ba.addEventListener(MouseEvent.MOUSE_DOWN, clickedAmp);
			g.addChild(ba);
			var bag1:Sprite = new Sprite();
			bag1.graphics.beginFill(0x00bb99);
			bag1.graphics.drawCircle(0, 0, 2);
			bag1.y = 60;
			bag1.x = 358;
			g.addChild(bag1);
			var bal1:Vera = new Vera('5', 10, 'l', 10);
			bal1.y = 53;
			bal1.x = 342;
			g.addChild(bal1);
			var bag3:Sprite = new Sprite();
			bag3.graphics.beginFill(0x00bb99);
			bag3.graphics.drawCircle(0, 0, 2);
			bag3.y = 51;
			bag3.x = 375;
			g.addChild(bag3);
			var bag5:Sprite = new Sprite();
			bag5.graphics.beginFill(0x00bb99);
			bag5.graphics.drawCircle(0, 0, 2);
			bag5.y = 60;
			bag5.x = 392;
			g.addChild(bag5);
			var bal5:Vera = new Vera('15', 20, 'l', 10);
			bal5.y = 53;
			bal5.x = 397;
			g.addChild(bal5);
			var lba:Vera = new Vera('Amplitude (V)', 80, 'l', 10);
			lba.y = 85;
			lba.x = 340;
			g.addChild(lba);
		}
		
		// fin de l'interface (enfin)
			
		// clic sur un bouton de pas
		
		public function clickedPas(e:MouseEvent):void
		{
			for(var i:int = 1; i <= 5; i++)
			{
				Sprite(g.getChildByName('p' + i.toString())).graphics.clear();
				Sprite(g.getChildByName('p' + i.toString())).graphics.lineStyle(3, 0x00bb99);
				Sprite(g.getChildByName('p' + i.toString())).graphics.beginFill(0xFFFFFF);
				Sprite(g.getChildByName('p' + i.toString())).graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			}
			Sprite(e.currentTarget).graphics.clear();
			Sprite(e.currentTarget).graphics.lineStyle(3, 0x00bb99);
			Sprite(e.currentTarget).graphics.beginFill(0x00bb99);
			Sprite(e.currentTarget).graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			s.setPas(Math.pow(10, (int(e.currentTarget.name.charAt(1))-1)));
			if(e.currentTarget.name == 'p4' || e.currentTarget.name == 'p5')
			{
				Sprite(g.getChildByName('l1')).graphics.clear();
				Sprite(g.getChildByName('l1')).graphics.lineStyle(3, 0xbbdddd);
				Sprite(g.getChildByName('l1')).graphics.lineTo(10, 0);
				Sprite(g.getChildByName('l2')).graphics.clear();
				Sprite(g.getChildByName('l2')).graphics.lineStyle(3, 0x00bb99);
				Sprite(g.getChildByName('l2')).graphics.lineTo(10, 0);
			}
			else
			{
				Sprite(g.getChildByName('l1')).graphics.clear();
				Sprite(g.getChildByName('l1')).graphics.lineStyle(3, 0x00bb99);
				Sprite(g.getChildByName('l1')).graphics.lineTo(10, 0);
				Sprite(g.getChildByName('l2')).graphics.clear();
				Sprite(g.getChildByName('l2')).graphics.lineStyle(3, 0xbbdddd);
				Sprite(g.getChildByName('l2')).graphics.lineTo(10, 0);
			}
			if(s.getPas() < 1000)
			{
				lct.setTexte((s.getPas() * s.getFreq()).toString());
			}
			else
			{
				lct.setTexte(((s.getPas() / 1000) * s.getFreq()).toString());
			}
		}
		
		// clic sur un bouton de forme
		
		public function clickedForme(e:MouseEvent):void
		{
			for(var i:int = 1; i <= 3; i++)
			{
				Sprite(g.getChildByName('f' + i.toString())).graphics.clear();
				Sprite(g.getChildByName('f' + i.toString())).graphics.lineStyle(3, 0x00bb99);
				Sprite(g.getChildByName('f' + i.toString())).graphics.beginFill(0xFFFFFF);
				Sprite(g.getChildByName('f' + i.toString())).graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			}
			Sprite(e.currentTarget).graphics.clear();
			Sprite(e.currentTarget).graphics.lineStyle(3, 0x00bb99);
			Sprite(e.currentTarget).graphics.beginFill(0x00bb99);
			Sprite(e.currentTarget).graphics.drawRoundRect(0, 0, 10, 10, 5, 5);
			if(e.currentTarget.name.charAt(1) == '1')
			{
				s.setForm('s');
			}
			else if(e.currentTarget.name.charAt(1) == '2')
			{
				s.setForm('c');
			}
			else if(e.currentTarget.name.charAt(1) == '3')
			{
				s.setForm('t');
			}
		}
		
		// clic sur le bouton de frequence
		
		public function clickedFreq(e:MouseEvent):void
		{
			f1 = Math.atan2(e.localY, e.localX);
			bf.addEventListener(MouseEvent.MOUSE_MOVE, changerFreq);
			g.addEventListener(MouseEvent.MOUSE_UP, lacherFreq);
		}
		
		// deplacement du bouton de frequence
			
		public function changerFreq(e:MouseEvent):void
		{	
			if(f1 - Math.atan2(e.localY, e.localX) > Math.PI/6)
			{
				if(bf.rotation > -120)
				{
					bf.rotation -= 30;
					f1 = Math.atan2(e.localY, e.localX);
				}
			}
			else if(f1 - Math.atan2(e.localY, e.localX) < -Math.PI/6)
			{
				if(bf.rotation < 120)
				{
					bf.rotation += 30;
					f1 = Math.atan2(e.localY, e.localX);
				}
			}
			if(bf.rotation < 30)
			{
				s.setFreq(Math.round(9+(bf.rotation / 30))/10);
			}
			else if(bf.rotation >= 30)
			{
				s.setFreq(bf.rotation/30);
			}
			if(s.getPas() < 1000)
			{
				lct.setTexte((s.getPas() * s.getFreq()).toString());
			}
			else
			{
				lct.setTexte(((s.getPas() / 1000) * s.getFreq()).toString());
			}	
		}
		
		// relachement du bouton de frequence
		
		public function lacherFreq(e:MouseEvent):void
		{
			bf.removeEventListener(MouseEvent.MOUSE_MOVE, changerFreq);
			g.removeEventListener(MouseEvent.MOUSE_UP, lacherFreq);
		}
		
		// clic sur le bouton de rapport cyclique
		
		public function clickedRap(e:MouseEvent):void
		{
			r1 = Math.atan2(e.localY, e.localX);
			br.addEventListener(MouseEvent.MOUSE_MOVE, changerRap);
			g.addEventListener(MouseEvent.MOUSE_UP, lacherRap);
		}
		
		// deplacement du bouton de rapport cyclique
		
		public function changerRap(e:MouseEvent):void
		{
			if(r1 - Math.atan2(e.localY, e.localX) > Math.PI/3)
			{
				if(br.rotation > -60)
				{
					br.rotation -= 60;
					r1 = Math.atan2(e.localY, e.localX);
				}
			}
			else if(r1 - Math.atan2(e.localY, e.localX) < -Math.PI/3)
			{
				if(br.rotation < 60)
				{
					br.rotation += 60;
					r1 = Math.atan2(e.localY, e.localX);
				}
			}
			if(br.rotation == 0)
			{
				s.setRap(0.50);
			}
			else if(br.rotation == -60)
			{
				s.setRap(0.25);
			}
			else if(br.rotation == 60)
			{
				s.setRap(0.75);
			}
		}
		
		// relachement du bouton de rapport cyclique
		
		public function lacherRap(e:MouseEvent):void
		{
			br.removeEventListener(MouseEvent.MOUSE_MOVE, changerRap);
			g.removeEventListener(MouseEvent.MOUSE_UP, lacherRap);
		}
			
		// clic sur le bouton d offset
		
		public function clickedOff(e:MouseEvent):void
		{
			o1 = Math.atan2(e.localY, e.localX);
			bo.addEventListener(MouseEvent.MOUSE_MOVE, changerOff);
			g.addEventListener(MouseEvent.MOUSE_UP, lacherOff);
		}
		
		// deplacement du bouton d offset
		
		public function changerOff(e:MouseEvent):void
		{
			if(o1 - Math.atan2(e.localY, e.localX) > Math.PI/3)
			{
				if(bo.rotation > -120)
				{
					bo.rotation -= 60;
					o1 = Math.atan2(e.localY, e.localX);
				}
			}
			else if(o1 - Math.atan2(e.localY, e.localX) < -Math.PI/3)
			{
				if(bo.rotation < 120)
				{
					bo.rotation += 60;
					o1 = Math.atan2(e.localY, e.localX);
				}
			}
			s.setOff(bo.rotation / 12);
		}
		
		// relachement du bouton d offset
		
		public function lacherOff(e:MouseEvent):void
		{
			bo.removeEventListener(MouseEvent.MOUSE_MOVE, changerOff);
			g.removeEventListener(MouseEvent.MOUSE_UP, lacherOff);
		}
		
		// clic sur le bouton d amplitude
		
		public function clickedAmp(e:MouseEvent):void
		{
			a1 = Math.atan2(e.localY, e.localX);
			ba.addEventListener(MouseEvent.MOUSE_MOVE, changerAmp);
			g.addEventListener(MouseEvent.MOUSE_UP, lacherAmp);
		}
		
		// deplacement du bouton d amplitude
		
		public function changerAmp(e:MouseEvent):void
		{
			if(a1 - Math.atan2(e.localY, e.localX) > Math.PI/3)
			{
				if(ba.rotation > -60)
				{
					ba.rotation -= 60;
					a1 = Math.atan2(e.localY, e.localX);
				}
			}
			else if(a1 - Math.atan2(e.localY, e.localX) < -Math.PI/3)
			{
				if(ba.rotation < 60)
				{
					ba.rotation += 60;
					a1 = Math.atan2(e.localY, e.localX);
				}
			}
			if(ba.rotation == 0)
			{
				s.setAmp(10);
			}
			else if(ba.rotation == -60)
			{
				s.setAmp(5);
			}
			else if(ba.rotation == 60)
			{
				s.setAmp(15);
			}
		}
		
		// relachement du bouton d amplitude
		
		public function lacherAmp(e:MouseEvent):void
		{
			ba.removeEventListener(MouseEvent.MOUSE_MOVE, changerAmp);
			g.removeEventListener(MouseEvent.MOUSE_UP, lacherAmp);
		}
		
		// mise en place de l evaluation et de la consigne
		public function evalea():void
		{	
			var txt:String = 'Réglez un signal de forme ';
			var esn:Number = Math.floor(3*Math.random()); // 0, 1, 2
			if(esn == 0) // signal sinusoidal
			{
				es = 's';
				er = 0.5;
				txt += 'sinusoidale';
			}
			else if(esn == 1) // signal rectangulaire
			{
				es = 'c';
				er = 0.25 + 0.25*(Math.floor(3*Math.random()));
				txt += 'rectangulaire, de rapport cyclique ';
				txt += er;
			}
			else // signal triangulaire
			{
				es = 't';
				er = 0.5;
				txt += 'triangulaire';
			}
			txt += ', de frequence ';
			var efn:Number = Math.floor(9*Math.random());
			if(efn < 5)
			{
				ef = 0.5 + 0.1*efn; // 0.5 à 0.9
			}
			else
			{
				ef = efn - 4; // 1 à 4
			}
			et = Math.pow(10, Math.floor(5*Math.random())); // pas temporel
			if(et < 1000)
			{
				txt += et*ef;
				txt += ' Hz';
			}
			else
			{
				txt += (et/1000)*ef;
				txt += ' kHz';
			}
			ea = 5 + 5*Math.floor(3*Math.random()); // amplitude
			txt += ', d\'amplitude ';
			txt += ea;
			eo = 5*(Math.floor(5*Math.random())-2); // -10, -5, 0, 5, 10
			txt += ' V et de valeur moyenne ';
			txt += eo;
			txt += ' V.';
				
			cs.setTexte(txt);
			
			// a la fin de chaque clic, comparaison a la consigne
			this.addEventListener(MouseEvent.MOUSE_UP, verif);
		}
		
		// verification de la consigne
		public function verif(e:MouseEvent):void
		{	
			var ok:int = 0; // reste à 0 si aucune erreur n est detectee
			if(s.getForm() != es)
			{
				ok = 1;
			}
			if(s.getRap() != er)
			{
				ok = 1;
			}
			if(s.getAmp() != ea)
			{
				ok = 1;
			}
			if(s.getOff() != eo)
			{
				ok = 1;
			}
			if(s.getFreq() != ef)
			{
				ok = 1;
			}
			if(s.getPas() != et)
			{
				ok = 1;
			}
			if(ok == 0) // aucune erreur, affichage du message de victoire
			{
				var b:int = g.numChildren;
				for(var j:int = 0; j < b; j++)
				{
					g.removeChildAt(0);
				}
				var win:Vera = new Vera('Félicitations, vous avez réussi !', 400, 'c', 16);
				win.y = 20;
				g.addChild(win);
				
				var rep:Vera = new Vera('Effectuer une nouvelle évaluation', 400, 'c', 12, 'vert');
				rep.y = 50;
				rep.buttonMode = true;
				g.addChild(rep);
				rep.addEventListener(MouseEvent.MOUSE_DOWN, replay);
				
			}
		}
		
		// appel d une nouvelle evaluation
		public function replay(e:MouseEvent):void
		{
			// le bouton fait appel a la navigation de l objet parent de type Page
			Page(this.parent).navig('e2');
		}
	}
}